/**************************************************************************
  __  __ _      _          _        __  __            _   _   _       _ 
 |  \/  (_)    | |        | |      |  \/  |          | | | | (_)     (_)
 | \  / |_  ___| |__   ___| | ___  | \  / | ___  __ _| |_| |_ _ _ __  _ 
 | |\/| | |/ __| '_ \ / _ \ |/ _ \ | |\/| |/ _ \/ _` | __| __| | '_ \| |
 | |  | | | (__| | | |  __/ |  __/ | |  | |  __/ (_| | |_| |_| | | | | |
 |_|  |_|_|\___|_| |_|\___|_|\___| |_|  |_|\___|\__,_|\__|\__|_|_| |_|_|
                                                                        
**************************************************************************/

#include <MFRC522.h>
#include <SPI.h>
#include <Keyboard.h>

#define SAD 10
#define RST 5

MFRC522 nfc(SAD, RST);

byte key[4] = {233, 189, 78, 211};

void setup() {
  Keyboard.begin();
  SPI.begin();
  // Read a fast as possible. There is a limit for how long we are
  // allowed to read from the tags.
  Serial.begin(115200);
  
  Serial.println("Looking for MFRC522.");
  nfc.begin();

  // Get the firmware version of the RFID chip
  byte version = nfc.getFirmwareVersion();
  if (! version) {
    Serial.print("Didn't find MFRC522 board.");
    while(1); //halt
  }
  Serial.print("Found chip MFRC522 ");
  Serial.print("Firmware ver. 0x");
  Serial.print(version, HEX);
  Serial.println(".");
  
}

void loop() {
  byte status;
  byte data[MAX_LEN];
  byte serial[5];
  int i, j, pos;

  // Send a general request out into the aether. If there is a tag in
  // the area it will respond and the status will be MI_OK.
  status = nfc.requestTag(MF1_REQIDL, data);

  if (status == MI_OK) {
    Serial.println("Tag detected.");
    Serial.print("Type: ");
    Serial.print(data[0], HEX);
    Serial.print(", ");
    Serial.println(data[1], HEX);

    // calculate the anti-collision value for the currently detected
    // tag and write the serial into the data array.
    status = nfc.antiCollision(data);
    memcpy(serial, data, 5);

    Serial.println("The serial nb of the tag is:");
    for (i = 0; i < 3; i++) {
      Serial.print(serial[i], DEC);
      Serial.print(", ");
    }
    Serial.println(serial[3], DEC);
    if(serial[0]==key[0] && serial[1]==key[1] && serial[2]==key[2] && serial[3]==key[3]){
      Keyboard.releaseAll(); 
      Keyboard.println();
      Keyboard.releaseAll();
      delay(300);
      Keyboard.println();
      Keyboard.releaseAll();
      delay(300);
      Keyboard.println("Password");
      Keyboard.releaseAll();
      delay(500);
    }
    // Select the tag that we want to talk to. If we don't do this the
    // chip does not know which tag it should talk if there should be
    // any other tags in the area..
    nfc.selectTag(serial);
    nfc.haltTag();
  }
  delay(2000);
}
